package com.bonait.bnframework.business;

import android.app.Activity;
import android.content.Context;
import android.content.ContextWrapper;
import android.os.Handler;
import android.util.Log;

import androidx.annotation.NonNull;

import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.db.QueryDB;
import com.bonait.bnframework.common.db.mode.BPA_GOODSRECIPE;
import com.bonait.bnframework.common.db.mode.BPA_MATERIAL;
import com.bonait.bnframework.common.db.mode.BPA_PLCADDRESS;
import com.bonait.bnframework.common.db.mode.BPA_SILOS;
import com.bonait.bnframework.common.helper.ByteHelper;
import com.bonait.bnframework.common.helper.I.IThread;
import com.bonait.bnframework.common.helper.I.IWriteCallBack;
import com.bonait.bnframework.common.helper.ThreadManager;
import com.bonait.bnframework.common.modbus.ModbusTcpServer;
import com.bonait.bnframework.common.utils.AlertDialogUtils;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.bonait.bnframework.modules.home.fragment.mode.LocationStatus;
import com.bonait.bnframework.modules.home.fragment.mode.MyStatus;
import com.qmuiteam.qmui.widget.dialog.QMUIDialog;
import com.qmuiteam.qmui.widget.dialog.QMUIDialogAction;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.IdentityHashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import kotlin.UShort;

/**
 * 执行配方
 */
public class ExecuteTheRecipe {

    //region 变量
    /**
     * 等待超时时间
     */
    public static int whileTime = 30;

    /**
     * 监听变量值
     */
    public static HashMap<String, Object> ListeningValue = new HashMap<String, Object>();

    /**
     * 外部界面
     */
    public static Context context = null;

    /**
     * 商品是否强制结束
     */
    public static boolean IsForcedEnd = false;

    /**
     * 当前配方
     */
    static ArrayList<BPA_GOODSRECIPE> all_list=new ArrayList<>();

    static BPA_GOODSRECIPE selectpf;
    /**
     * 当前工序的index
     */
    static int Index_select=0;
    //endregion

    //region 强制结束
    /**
     * 设置强制结束
     */
    public static void SetForcedEnd()
    {
        ToastUtils.info("客官,小菠萝正在强制结束当前炒制菜品,请耐心等候!!!");
        IsForcedEnd=true;
    }

    /**
     * 停止强制结束
     */
    public static void StopForcedEnd()
    {
        IsForcedEnd=false;
    }
    //endregion

    //region 执行配方
    /**
     * 执行配方
     *
     * @param recipe
     * @return
     */
    public static boolean Execute(BPA_GOODSRECIPE recipe,ArrayList<BPA_GOODSRECIPE> all,int index) {
        boolean status = false;
        all_list=all;
        selectpf=recipe;
        Index_select=index;
        try {
            //1.解析
            if(IsForcedEnd)
            {
                ToastUtils.info("客官,小菠萝正在强制结束当前炒制菜品,请耐心等候!!!");
                return false;
            }
            ToastUtils.info("开始执行:" + recipe.sort + "、" + recipe.processms);
            if (recipe.materialType == 0)//正常物料
            {
                ExecuteMaterialIssuance(recipe.processvalue);
            } else if (recipe.materialType == 1)//工序模型
            {
                ExecuteOperationSteps(recipe.processname, recipe.processvalue);
            }
        } catch (Exception ex) {
            ToastUtils.error("异常信息:" + ex.getMessage());
            status = false;
        } finally {
            return status;
        }
    }

    /**
     * 液体物料信息-配料
     *
     * @param text
     */
    private static void ExecuteMaterialIssuance(String text) {
        try {
            ToastUtils.info("准备下料！！！");

            if (!text.isEmpty()) {
                //仓号 值
                HashMap<Integer, Integer> formulation = new HashMap<>();
                //region 获取仓号和值
                List<String> data = new ArrayList<>();
                if (text.contains("|")) {
                    String[] res = text.split("[|]");
                    for (int i = 0; i < res.length; i++) {
                        data.add(res[i]);
                    }
                } else {
                    data.add(text);
                }
                for (String item : data) {
                    if (!item.isEmpty() && item.contains(",")) {
                        String[] wl = item.split("[,]");
                        if (wl != null && wl.length == 2) {
                            String name = wl[0];
                            int val = (int)Math.round((Double.parseDouble(wl[1]) * 10));
                            //int val = Integer.parseInt(wl[1]);
                            List<BPA_SILOS> bpa_silos = QueryDB.GetSolisByMaterialName(name);
                            if (bpa_silos.size() > 0 && val > 0) {
                                BPA_SILOS silos = bpa_silos.get(0);
                                formulation.put(silos.num, val);
                            }
                        }
                    }
                }
                //endregion
                //写入PLC,直接出料，不用等待
                for (Map.Entry<Integer, Integer> entry : formulation.entrySet()) {
                    Integer key = entry.getKey();
                    Integer value = entry.getValue();
                    Write_PLC_Material(key, value);
                }

                Thread.sleep(200);//等待写入完成

                //一直等待下料完成 否则就一直等待 40s超时
                for (Map.Entry<Integer, Integer> entry : formulation.entrySet()) {
                    Integer num = entry.getKey();
                    Integer val = entry.getValue();
                    String name = "料仓" + num + "下料完成";
                    final boolean[] IsComplete = {false};
                    long a = System.currentTimeMillis();
                    while (!IsComplete[0]) {
                        if ((System.currentTimeMillis() - a) > 1000 * whileTime) {
                            break;
                        } else {
                            Object sb = ReadPLC(name);//    ListeningValue.get(name);
                            if (sb != null) {
                                IsComplete[0] = (boolean) (sb);
                            }
                        }
                        Thread.sleep(100);//10 *6
                    }
                    ToastUtils.info(name);
                }
            }
        } catch (Exception ex) {
            ToastUtils.error("异常信息:" + ex.getMessage());
        }
    }

    /**
     * 执行工序步骤
     *
     * @param text
     */
    private static void ExecuteOperationSteps(String processname, String text) {
        try {
            if (!text.isEmpty() && !processname.isEmpty()) {
                //工序名称和值
                HashMap<String, String> formulation = new HashMap<>();
                //region 获取仓号和值
                List<String> data = new ArrayList<>();
                if (text.contains("|")) {
                    String[] res = text.split("[|]");
                    for (int i = 0; i < res.length; i++) {
                        data.add(res[i]);
                    }
                } else {
                    data.add(text);
                }
                for (String item : data) {
                    if (!item.isEmpty() && item.contains(",")) {
                        String[] wl = item.split("[,]");
                        if (wl != null && wl.length == 2) {
                            String name = wl[0];
                            String val = wl[1];
                            formulation.put(name, val);
                        }
                    }
                }
                //endregion
                //写入PLC
                if (formulation.size() > 0) {
                    switch (processname) {
                        case "搅拌":
                            Write_PLC_Stir(formulation);
                            break;
                        case "位置":
                            Write_PLC_Location(formulation);
                            break;
                        case "加热":
                            Write_PLC_Heating(formulation);
                            break;
                        case "主料":
                            Write_PLC_Ingredients(formulation);
                            break;
                        case "延迟":
                            Write_PLC_Delay(formulation);
                            break;
                        case "出菜":
                            Write_PLC_Outdishes(formulation);
                            break;
                    }
                }
            }
        } catch (Exception ex) {
            ToastUtils.error("异常信息:" + ex.getMessage());
        }
    }
    //endregion

    //region 物料PLC控制

    /**
     * 写入仓号需求值
     *
     * @param num
     * @param val
     */
    private static void Write_PLC_Material(int num, int val) {
        try {
            ToastUtils.info("准备写入PLC仓号需求:" + num + "," + val/10.0);

            String name = "料仓" + num + "下料完成";
            ExecuteTheRecipe.WritePLC(name, false, null);

            final boolean[] IsComplete = {false};

            WritePLC("料仓" + num + "需求值", val, new IWriteCallBack() {
                @Override
                public void onSuccess() {
                    BottomClick("料仓" + num + "下料");
                    IsComplete[0] = true;
                }

                @Override
                public void onFailure(String ErrorMsg) {
                }
            });
            long a = System.currentTimeMillis();
            while (!IsComplete[0]) {
                if ((System.currentTimeMillis() - a) > 1000 * whileTime) {
                    break;
                }
                Thread.sleep(100);//10 *6
            }
            ToastUtils.info("写入PLC仓号需求:" + num + "," + val/10.0);
        } catch (Exception ex) {
            ToastUtils.error("异常信息:" + ex.getMessage());
        }
    }
    //endregion

    //region 写PLC工序

    /**
     * 写PLC搅拌
     *
     * @param data
     */
    private static void Write_PLC_Stir(HashMap<String, String> data) {
        try {
            int val=0;

            for (HashMap.Entry<String, String> entry : data.entrySet()) {
                String key = entry.getKey();
                String value = entry.getValue();
                ToastUtils.info("工序:" + key + "," + value);
                if (key.contains("(秒)")) {
                    val = Integer.parseInt(value);
                } else {
                    int writeValue = GetMXValue(key, value);
                    WritePLC(key, writeValue, new IWriteCallBack() {
                        @Override
                        public void onSuccess() {
                            if (writeValue == 0) {
                                WritePLC("搅拌", false, null);
                            } else {
                                WritePLC("搅拌", true, null);
                            }
                        }

                        @Override
                        public void onFailure(String ErrorMsg) {
                        }
                    });
                }
            }

            if(val>0)
            {
                Thread.sleep(val * 1000);
            }
        } catch (Exception ex) {
            ToastUtils.error("异常信息:" + ex.getMessage());
        }
    }

    /**
     * 写PLC位置
     *
     * @param data
     */
    private static void Write_PLC_Location(HashMap<String, String> data) {
        try {
            int val=0;
            ToastUtils.info("准备控制炒锅移动!!!");
            for (HashMap.Entry<String, String> entry : data.entrySet()) {
                String key = entry.getKey();
                String value = entry.getValue();
                if (key.contains("(秒)")) {
                    val = Integer.parseInt(value);
                } else if (key.contains("速度")) {
                    int writeValue = GetMXValue(key, value);
                    WritePLC(key, writeValue, null);
                }
            }

            for (HashMap.Entry<String, String> entry : data.entrySet()) {
                String key = entry.getKey();
                String value = entry.getValue();
                ToastUtils.info("工序:" + key + "," + value);
                if (!key.contains("(秒)") && !key.contains("速度")) {
                    //原点位,等待机器移动倒响应位置
                    BottomClick(value);

                    //一直等待机器移动到该位置，否则就一直等待 6s超时
                    String name = value + "反馈";
                    final boolean[] IsComplete = {false};
                    long a = System.currentTimeMillis();
                    while (!IsComplete[0]) {
                        if ((System.currentTimeMillis() - a) > 1000 * whileTime) {
                            break;
                        } else {
                            Object sb = ReadPLC(name);//ListeningValue.get(name);
                            if (sb != null) {
                                IsComplete[0] = (boolean) (sb);
                            }
                        }
                        Thread.sleep(100);//10 *6
                    }
                    ToastUtils.info("炒锅到达"+value+",继续制作!!!");
                }
            }

            if(val>0)
            {
                Thread.sleep(val * 1000);
            }
        } catch (Exception ex) {
            ToastUtils.error("异常信息:" + ex.getMessage());
        }
    }

    /**
     * 写PLC主料
     *
     * @param data
     */
    private static void Write_PLC_Ingredients(HashMap<String, String> data) {
        try {
            //是否手动
            boolean ishand=true;
            ToastUtils.info("准备倒入主料！");

            //region 判断是否手动
            if(ConfigName.getInstance().versionSelectionEnum.equals("大炒版本"))
            {
                ishand=true;
            }else
            {
                for (HashMap.Entry<String, String> entry : data.entrySet()) {
                    String key = entry.getKey();
                    String value = entry.getValue();
                    if (key.contains("投料动作")) {
                        if(value.contains("手动投料"))
                        {
                            ishand=true;
                        }else
                        {
                            ishand=false;
                        }
                    }
                }
            }
            //endregion



            if(ishand)
            {
                if(ConfigName.getInstance().versionSelectionEnum.equals("大炒自动投料版本") || ConfigName.getInstance().versionSelectionEnum.equals("小炒版本"))
                {
                    ExecuteTheRecipe.BottomClick("平移-去1号位");
                }
                String name = "";
                String zl = "";
                int val = 0;
                for (HashMap.Entry<String, String> entry : data.entrySet()) {
                    String key = entry.getKey();
                    String value = entry.getValue();
                    if (key.contains("名称")) {
                        name = value;
                    } else if (key.contains("重量")) {
                        zl = value;
                    }
                }
                ToastUtils.info("工序:手动投料," + name + "," + zl);
                String title = "手动投料-温馨提示！";
                String message = "客官请投入主料,[" + name + "]重量" + zl + "g,投入后点击[确定]继续流程！";

                final boolean[] IsComplete = {false};
                Activity activity = findActivity(context);
                if (activity != null) {
                    activity.runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            try {
                                AlertDialogUtils.showDialog(context, title, message, new QMUIDialogAction.ActionListener() {
                                    @Override
                                    public void onClick(QMUIDialog dialog, int index) {
                                        IsComplete[0] = true;
                                        dialog.dismiss();
                                    }
                                });
                            } catch (Exception e) {

                            }
                        }
                    });
                }

                while (!IsComplete[0]) {
                    Thread.sleep(100);//10 *6
                }
                ToastUtils.info("确定完成,继续制作！");
            }else
            {
                //自动投料
                if(ConfigName.getInstance().versionSelectionEnum.equals("大炒自动投料版本") || ConfigName.getInstance().versionSelectionEnum.equals("小炒版本"))
                {
                    String writeValue = "1号位";
                    for (HashMap.Entry<String, String> entry : data.entrySet()) {
                        String key = entry.getKey();
                        String value = entry.getValue();
                        if (key.contains("主料位置")) {
                            writeValue=value;
                        }
                    }

                    //1.去某一个位置
                    BottomClick("平移-去"+writeValue);
                    Log.d("平移", "平移-去"+writeValue);
                    //一直等待机器移动到该位置，否则就一直等待 6s超时
                    String name = "平移轴在"+writeValue;
                    final boolean[] IsComplete = {false};
                    long a = System.currentTimeMillis();
                    while (!IsComplete[0]) {
                        if ((System.currentTimeMillis() - a) > 1000 * whileTime) {
                            break;
                        } else {
                            Object sb =ReadPLC(name);// ListeningValue.get(name);
                            if (sb != null) {
                                IsComplete[0] = (boolean) (sb);
                            }
                        }
                        Thread.sleep(100);//10 *6
                    }
                    Log.d("平移", name+"已经就位");

                    //2.给倒菜启动
                    BottomClick("主料");
                    name = "倒菜完成";
                    IsComplete[0]=false;
                    a = System.currentTimeMillis();
                    while (!IsComplete[0]) {
                        if ((System.currentTimeMillis() - a) > 1000 * whileTime) {
                            break;
                        } else {
                            Object sb =ReadPLC(name);// ListeningValue.get(name);
                            if (sb != null) {
                                IsComplete[0] = (boolean) (sb);
                            }
                        }
                        Thread.sleep(100);//10 *6
                    }
                    ToastUtils.info("主料倒入完成,继续制作！");

                }
            }
            Log.d("倒菜", "倒菜完成了");

            if(IsMoveYiHaoWei())
            {
                if(ConfigName.getInstance().versionSelectionEnum.equals("大炒自动投料版本") || ConfigName.getInstance().versionSelectionEnum.equals("小炒版本"))
                {
                    ExecuteTheRecipe.BottomClick("平移-去1号位");
                    Log.d("移动去", "1号位");
                }
            }

            //判断是否有烹饪时间
            int val=0;
            for (HashMap.Entry<String, String> entry : data.entrySet()) {
                String key = entry.getKey();
                String value = entry.getValue();
                if (key.contains("(秒)")) {
                    val = Integer.parseInt(value);
                }
            }
            if(val>0)
            {
                Thread.sleep(val * 1000);
            }

            Log.d("烹饪时间", "烹饪时间完成了");


        } catch (Exception ex) {
            ToastUtils.error("异常信息:" + ex.getMessage());
        }
    }

    /**
     * 按下
     * @param name
     */
    public static void BottomClick(String name)
    {
        try
        {
            WritePLC(name,true,null);
            new Handler().postDelayed(new Runnable() {
                @Override
                public void run() {
                    ExecuteTheRecipe.WritePLC(name, false, null);
                }
            }, 500);
        }catch (Exception ex)
        {

        }
    }

    private static Activity findActivity(@NonNull Context context) {
        if (context instanceof Activity) {
            return (Activity) context;
        } else if (context instanceof ContextWrapper) {
            return findActivity(((ContextWrapper) context).getBaseContext());
        } else {
            return null;
        }
    }

    /**
     * 写PLC 加热
     *
     * @param data
     */
    private static void Write_PLC_Heating(HashMap<String, String> data) {
        try {
            int val=0;
            for (HashMap.Entry<String, String> entry : data.entrySet()) {
                String key = entry.getKey();
                String value = entry.getValue();
                ToastUtils.info("工序:" + key + "," + value);
                if (key.contains("(秒)")) {
                    val = Integer.parseInt(value);
                } else {
                    int writeValue = GetMXValue(key, value);
                    WritePLC(key, writeValue, new IWriteCallBack() {
                        @Override
                        public void onSuccess() {
                            if (writeValue == 0) {
                                WritePLC("加热", false, null);
                            } else {
                                WritePLC("加热", true, null);
                            }
                        }

                        @Override
                        public void onFailure(String ErrorMsg) {
                        }
                    });
                }
            }

            if(val>0)
            {
                Thread.sleep(val * 1000);
            }

        } catch (Exception ex) {
            ToastUtils.error("异常信息:" + ex.getMessage());
        }
    }

    /**
     * 写PLC 延迟
     *
     * @param data
     */
    private static void Write_PLC_Delay(HashMap<String, String> data) {
        try {
            for (HashMap.Entry<String, String> entry : data.entrySet()) {
                String key = entry.getKey();
                String value = entry.getValue();
                ToastUtils.info("工序:" + key + "," + value);
                if (key.contains("(秒)")) {
                    int val = Integer.parseInt(value);
                    Thread.sleep(val * 1000);
                }
            }
        } catch (Exception ex) {
            ToastUtils.error("异常信息:" + ex.getMessage());
        }
    }

    /**
     * 写PLC 出菜
     *
     * @param data
     */
    private static void Write_PLC_Outdishes(HashMap<String, String> data) {
        try {
            ToastUtils.info("准备出菜！");

            BottomClick("出菜");

            //一直等待机器移动到该位置，否则就一直等待 6s超时
            String name = "出餐启动反馈";
            final boolean[] IsComplete = {false};
            long a = System.currentTimeMillis();
            while (!IsComplete[0]) {
                if ((System.currentTimeMillis() - a) > 1000 * 120) {
                    break;
                } else {
                    Object sb =ReadPLC(name);//ListeningValue.get(name);
                    if (sb != null) {
                        IsComplete[0] = (boolean) (sb);
                    }
                }
                Thread.sleep(100);//10 *6
            }


            for (HashMap.Entry<String, String> entry : data.entrySet()) {
                String key = entry.getKey();
                String value = entry.getValue();
                ToastUtils.info("工序:" + key + "," + value);
                if (key.contains("(秒)")) {
                    int val = Integer.parseInt(value);
                    Thread.sleep(val * 1000);
                }
            }
            ToastUtils.info("出菜完成,结束制作！");
        } catch (Exception ex) {
            ToastUtils.error("异常信息:" + ex.getMessage());
        }
    }
    //endregion

    //region 判断当前工序后是否还有 主料  不包含 手动配料

    /**
     * 是否还有 主料  不包含 手动配料  如果没有主料的话 那么就是对的
     * @return
     */
    public static  boolean IsMoveYiHaoWei()
    {
        boolean IsMove=false;
        try{
            int k=0;
            ArrayList<BPA_GOODSRECIPE> kkkkkk=new ArrayList<>();
            for (BPA_GOODSRECIPE item:all_list)
            {
                if(k>Index_select) //查找当前工序 后的步骤 所有主料
                {
                    if(item.processname.contains("主料") && !item.processvalue.contains("手动投料"))// &&
                    {
                        kkkkkk.add(item);
                    }
                }
                k++;
            }

            if(kkkkkk.size()<=0)
            {
                IsMove=true;
            }

        }catch (Exception ex)
        {

        }finally {
            return IsMove;
        }
    }
    //endregion

    //region 主页按钮
    /**
     * 点击摇欠按钮
     *
     * @param data
     */
    public static void Write_PLC_YaoQian(MyStatus data) {
        try {
            if (data == MyStatus.Start) {
                ToastUtils.info("点击摇浅按钮");

            } else if (data == MyStatus.Stop) {
                ToastUtils.info("点击停摇按钮");
            }
        } catch (Exception ex) {
            ToastUtils.error("异常信息:" + ex.getMessage());
        }
    }

    /**
     * 火力点击
     *
     * @param data
     */
    public static void Write_PLC_HuoLI(int data) {
        try {
            WritePLC("加热功率", data, new IWriteCallBack() {
                @Override
                public void onSuccess() {
                    if (data == 0) {
                        WritePLC("加热", false, null);
                    } else {
                        WritePLC("加热", true, null);
                    }
                }

                @Override
                public void onFailure(String ErrorMsg) {
                }
            });
            ToastUtils.info("火力按钮点击,当前级别：" + data);

        } catch (Exception ex) {
            ToastUtils.error("异常信息:" + ex.getMessage());
        }
    }
    //endregion

    //region PLC监听线程
    public static void Listening() {

        ConfigName.getInstance().PLC_Address.clear();
        ArrayList<BPA_PLCADDRESS> address = QueryDB.GetPlcaddressALL();
        for (BPA_PLCADDRESS item : address) {
            if (!item.address.isEmpty() && !item.address.equals("-------------")) {
                ConfigName.getInstance().PLC_Address.put(item.name, item);
            }
        }

        new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    WritePLC("初始化",true,null);
                    Thread.sleep(500);
                    WritePLC("初始化",false,null);
                } catch (InterruptedException e) {
                    ToastUtils.info("异常信息:" + e.getMessage());
                }
            }
        }).start();


        ThreadManager.Get().StartLong("PLC设备数据监听", true, new IThread() {
            @Override
            public void Run() throws InterruptedException {
                try {
                    for (String item : ConfigName.getInstance().PLC_Address.keySet()) {
                        String key = item;
                        BPA_PLCADDRESS plcaddress = ConfigName.getInstance().PLC_Address.get(item);
                        if (plcaddress.isread == 1) {
                            Object val = ReadPLC(key);
                            ListeningValue.put(key, val);
                        }
                    }

                    ReadPLCStatus();
                } catch (Exception ex) {
                    ToastUtils.error("异常信息:" + ex.getMessage());
                }
                Thread.sleep(100);
            }

            @Override
            public void RunComplete() throws InterruptedException {

            }
        });
    }
    //endregion

    //region PLC基础控制类

    /**
     * 写PLC数据
     *
     * @param name
     * @param value
     */
    public static void WritePLC(String name, Object value, IWriteCallBack callback) {
        try {
            if (ConfigName.getInstance().PLC_Address.containsKey(name)) {
                BPA_PLCADDRESS plcaddress = ConfigName.getInstance().PLC_Address.get(name);
                if (!plcaddress.address.isEmpty() && ConfigName.getInstance().PlcIsConnect) {
                    if (plcaddress.address.toUpperCase().startsWith("VD"))//int
                    {
                        ModbusTcpServer.get().WriteInt(plcaddress.address, (int) value, callback);
                    } else if (plcaddress.address.toUpperCase().startsWith("M"))//bool
                    {
                        ModbusTcpServer.get().WriteBool(plcaddress.address, (boolean) value, callback);
                    } else if (plcaddress.address.toUpperCase().startsWith("VW"))//short
                    {
                        ModbusTcpServer.get().WriteShort(plcaddress.address, Short.parseShort(value.toString()), callback);
                    }
                }
            }
        } catch (Exception ex) {
            ToastUtils.error("异常信息:" + ex.getMessage());
        } finally {

        }
    }

    /**
     * 读PLC数据
     *
     * @param name
     * @return
     */
    public static Object ReadPLC(String name) {
        final Object[] ReturnsVariable = {null};
        try {
            if (ConfigName.getInstance().PLC_Address.containsKey(name)) {
                BPA_PLCADDRESS plcaddress = ConfigName.getInstance().PLC_Address.get(name);
                if (!plcaddress.address.isEmpty() && ConfigName.getInstance().PlcIsConnect) {
                    if (plcaddress.address.toUpperCase().startsWith("VD"))//int
                    {

                        ModbusTcpServer.get().ReadInt(plcaddress.address, 1, ints -> {
                            ReturnsVariable[0] = ints[0];
                        });
                    } else if (plcaddress.address.toUpperCase().startsWith("M"))//bool
                    {
                        ModbusTcpServer.get().ReadBool(plcaddress.address, 1, val -> {
                            ReturnsVariable[0] = val[0];
                        });
                    } else if (plcaddress.address.toUpperCase().startsWith("VW"))//short
                    {
                        ModbusTcpServer.get().ReadShort(plcaddress.address, 1, val -> {
                            ReturnsVariable[0] = val[0];
                        });
                    }
                }
            }
        } catch (Exception ex) {
            ToastUtils.error("异常信息:" + ex.getMessage());
        } finally {
            return ReturnsVariable[0];
        }
    }

    /**
     * 实时状态
     */
    public static ConcurrentHashMap<Integer, Boolean> IoStatus = new ConcurrentHashMap<Integer, Boolean>();

    /**
     * 获取实时状态
     *
     * @param ch
     * @return
     */
    public static boolean getConcurrentHash(int ch) {
        if (!IoStatus.containsKey(ch)) {
            return false;
        }
        return IoStatus.get(ch);
    }

    /**
     * 获取搅拌电机
     *
     * @param
     * @return
     */
    public static int getConcurrentHash_dj(String name) {
        if (!ListeningValue.containsKey(name)) {
            return 0;
        }
        Object obj = ListeningValue.get(name);
        if (obj == null) {
            return 0;
        } else {
            return (int) obj;
        }
    }

    /**
     * 获取监听变量
     *
     * @param
     * @return
     */
    public static Object getListingValue(String name) {
        if (!ListeningValue.containsKey(name)) {
            return null;
        }
        return ListeningValue.get(name);
    }

    /**
     * 读取状态
     */
    public static void ReadPLCStatus() {
        try {
            if (ConfigName.getInstance().PlcIsConnect) {
                ModbusTcpServer.get().ReadStatus("VW354", 1, data -> {
                    for (int i = 0; i < data.length; i++) {
                        byte status = data[i];//0x92
                        IoStatus.put(i * 8 + 0, ByteHelper.getBit(status, 0) == 1);
                        IoStatus.put(i * 8 + 1, ByteHelper.getBit(status, 1) == 1);
                        IoStatus.put(i * 8 + 2, ByteHelper.getBit(status, 2) == 1);
                        IoStatus.put(i * 8 + 3, ByteHelper.getBit(status, 3) == 1);
                        IoStatus.put(i * 8 + 4, ByteHelper.getBit(status, 4) == 1);
                        IoStatus.put(i * 8 + 5, ByteHelper.getBit(status, 5) == 1);
                        IoStatus.put(i * 8 + 6, ByteHelper.getBit(status, 6) == 1);
                        IoStatus.put(i * 8 + 7, ByteHelper.getBit(status, 7) == 1);
                    }
                });
            }
        } catch (Exception ex) {
            ToastUtils.error("异常信息:" + ex.getMessage());
        } finally {
        }
    }
    //endregion

    //region 获取基础挡位变量
    /**
     * 获取挡位变量
     *
     * @param name
     * @param value
     * @return
     */
    public static int GetMXValue(String name, String value) {
        final int[] ReturnsVariable = {0};
        try {
            if (name.contains("速度")) {
                ReturnsVariable[0] = ConfigName.getInstance().StirringSpeed.get(value);
            } else if (name.contains("功率")) {
                ReturnsVariable[0] = ConfigName.getInstance().HeatingGear.get(value);
                int max= ConfigName.getInstance().HeatingGear.get( ConfigName.getInstance().HuoLi);
                if(ReturnsVariable[0]>max)
                {
                    ReturnsVariable[0]=max;
                }
            }
        } catch (Exception ex) {
            ToastUtils.error("异常信息:" + ex.getMessage());
        } finally {
            return ReturnsVariable[0];
        }
    }
    //endregion
}
