package com.bonait.bnframework.modules.home.activity;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.fragment.app.Fragment;
import androidx.viewpager.widget.ViewPager;

import android.os.Bundle;
import android.view.MenuItem;
import android.widget.RelativeLayout;

import com.bonait.bnframework.R;
import com.bonait.bnframework.common.base.BaseActivity;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.constant.MessageName;
import com.bonait.bnframework.common.message.MessageLooper;
import com.bonait.bnframework.common.message.MessageManager;
import com.bonait.bnframework.common.tabbar.MainNavigateTabBar;
import com.bonait.bnframework.modules.home.adapter.FragmentAdapter;
import com.bonait.bnframework.modules.home.fragment.DingDanfragment;
import com.bonait.bnframework.modules.home.fragment.GongnengFragment;
import com.bonait.bnframework.modules.home.fragment.GuanLifragment;
import com.bonait.bnframework.modules.home.fragment.Home1Fragment;
import com.bonait.bnframework.modules.home.fragment.Home2Fragment;
import com.bonait.bnframework.modules.home.fragment.JiaoYanFragment;
import com.bonait.bnframework.modules.home.fragment.MakeGoodFragment;
import com.bonait.bnframework.modules.home.fragment.SheZhifragment;
import com.bonait.bnframework.modules.mine.fragment.MyFragment;
import com.google.android.material.bottomnavigation.BottomNavigationView;
import com.qmuiteam.qmui.widget.QMUIViewPager;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;

public class BottomNavigationMainActivity extends BaseActivity {

    @BindView(R.id.mainTabBar)
    MainNavigateTabBar mNavigateTabBar;

    @BindView(R.id.viewpager)
    QMUIViewPager viewPager;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_bottom_navigation_main);

        ButterKnife.bind(this);

        mNavigateTabBar.onRestoreInstanceState(savedInstanceState);
        mNavigateTabBar.addTab(null, new MainNavigateTabBar.TabParam(R.mipmap.gongneng, R.mipmap.gongneng_selected, "功能"));
        mNavigateTabBar.addTab(null, new MainNavigateTabBar.TabParam(R.mipmap.jiaoyan, R.mipmap.jiaoyan_selected, "校验"));
        mNavigateTabBar.addTab(null, new MainNavigateTabBar.TabParam(R.mipmap.dingdan, R.mipmap.dingdan_selected, "订单"));
        mNavigateTabBar.addTab(null, new MainNavigateTabBar.TabParam(0, 0, ""));
        mNavigateTabBar.addTab(null, new MainNavigateTabBar.TabParam(R.mipmap.comui_tab_message, R.mipmap.comui_tab_message_selected, "管理"));
        mNavigateTabBar.addTab(null, new MainNavigateTabBar.TabParam(R.mipmap.shezhi, R.mipmap.shezhi_selected, "设置"));
        mNavigateTabBar.addTab(null, new MainNavigateTabBar.TabParam(R.mipmap.comui_tab_person, R.mipmap.comui_tab_person_selected, "我的"));
        mNavigateTabBar.setTabSelectListener(mOnNavigationItemSelectedListener);
        initFragment();

    }
    private List<Fragment> fragmentList;
    /**
     * viewPager里添加fragment
     */
    private void initFragment() {
        fragmentList = new ArrayList<>();
        for (Fragment item:ConfigName.getInstance().fragmentList)
        {
            fragmentList.add(item);
        }
        ConfigName.getInstance().fragmentAdapter = new FragmentAdapter(getSupportFragmentManager(),fragmentList);
        viewPager.setAdapter(ConfigName.getInstance().fragmentAdapter);
        ConfigName.getInstance().fragmentAdapter.SetViewPage(viewPager);
        //手指滑动
        viewPager.addOnPageChangeListener(pageChangeListener);
        // 设置viewPager缓存多少个fragment
        viewPager.setOffscreenPageLimit(7);

        // 再来一杯
        viewPager.setCurrentItem(3);
    }

    /**
     * 配置bottom底部菜单栏监听器，手指点击底部菜单监听
     */
    private MainNavigateTabBar.OnTabSelectedListener mOnNavigationItemSelectedListener
            = new MainNavigateTabBar.OnTabSelectedListener() {
        @Override
        public void onTabSelected(MainNavigateTabBar.ViewHolder holder) {
            switch (holder.tag) {
                case "功能":
                    viewPager.setCurrentItem(0);
                    break;
                case "校验":
                    viewPager.setCurrentItem(1);
                    break;
                case "订单":
                    viewPager.setCurrentItem(2);
                    break;
                case "管理":
                    viewPager.setCurrentItem(4);
                    break;
                case "设置":
                    viewPager.setCurrentItem(5);
                    break;
                case "我的":
                    viewPager.setCurrentItem(6);
                    break;
                case "":
                    viewPager.setCurrentItem(3);
                    break;
            }
        }
    };
    /**
     * 配置ViewPager监听器，手指滑动监听
     */
    private ViewPager.OnPageChangeListener pageChangeListener = new ViewPager.OnPageChangeListener() {
        @Override
        public void onPageScrolled(int position, float positionOffset, int positionOffsetPixels) {
        }
        @Override
        public void onPageSelected(int position) {
            mNavigateTabBar.setCurrentSelectedTab(position);
        }
        @Override
        public void onPageScrollStateChanged(int state) {
        }
    };
}