package com.bonait.bnframework.modules.home.adapter;

import android.app.Activity;
import android.content.Context;
import android.content.ContextWrapper;
import android.content.DialogInterface;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.recyclerview.widget.RecyclerView;

import com.bonait.bnframework.R;
import com.bonait.bnframework.common.db.QueryDB;
import com.bonait.bnframework.common.db.mode.BPA_GOODPROPERTY;
import com.bonait.bnframework.common.db.mode.BPA_MATERIAL;
import com.bonait.bnframework.common.db.mode.BPA_SILOSANDMATERIAL;
import com.bonait.bnframework.common.db.res.lcMode;
import com.bonait.bnframework.common.helper.I.MyClickListener;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.bonait.bnframework.common.view.MyLayoutManager;
import com.qmuiteam.qmui.widget.dialog.QMUIDialog;

import java.util.ArrayList;
import java.util.List;


public class liaochang_adapter extends RecyclerView.Adapter<RecyclerView.ViewHolder> {

    private final LayoutInflater mLayoutInflater;

    private Context context;

    List<Object> liaos = new ArrayList<>();

    public liaochang_adapter(Context context,List<Object> data) {
        this.context = context;
        mLayoutInflater = LayoutInflater.from(context);
        liaos=data;
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View inflate = mLayoutInflater.inflate(R.layout.liaochang_item, parent, false);
        return new MyLCViewHolder1(inflate);
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        try {
            if (holder instanceof MyLCViewHolder1) {

                lcMode lcMode = (lcMode)liaos.get(position);
                MyLCViewHolder1 myViewHolder = (MyLCViewHolder1) holder;

                myViewHolder.xuhao.setText(lcMode.num+"");
                myViewHolder.name.setText(lcMode.materialName.isEmpty()?"未设置":(lcMode.materialName+""));
                if(lcMode.materialName.isEmpty() || lcMode.materialName.equals("未设置"))
                {
                    myViewHolder.wuliaoimage.setImageResource(R.mipmap.liaochang);
                }else
                {
                    myViewHolder.wuliaoimage.setImageResource(R.mipmap.liaochang_select);
                }

                myViewHolder.wuliaoimage.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View view) {
                        List<String> names = new ArrayList<>();
                        int index = 0;
                        int count = 0;
                        ArrayList<BPA_MATERIAL> materials = new ArrayList<>();
                        List<BPA_MATERIAL> bpa_materials = QueryDB.GetMaterialALL();
                        for (BPA_MATERIAL item : bpa_materials) {
                            materials.add(item);
                        }
                        BPA_MATERIAL wsz = new BPA_MATERIAL();
                        wsz.name = "未设置";
                        wsz.id = "";
                        materials.add(wsz);
                        for (BPA_MATERIAL item : materials) {
                            names.add(item.name);
                            if (item.name.equals(lcMode.materialName)) {
                                index = count;
                            }
                            count++;
                        }
                        String[] items = names.toArray(new String[names.size()]);
                        final int checkIndex = index;
                        new QMUIDialog.CheckableDialogBuilder(context)
                                .addItems(items, new DialogInterface.OnClickListener() {
                                    @Override
                                    public void onClick(DialogInterface dialog, int which) {

                                        BPA_SILOSANDMATERIAL item = new BPA_SILOSANDMATERIAL();
                                        BPA_MATERIAL material = materials.get(which);
                                        item.silosID = lcMode.id;
                                        item.materialID = material.id;
                                        //更新
                                        if (QueryDB.UpdateSilosAndMaterial(item)) {
                                            lcMode.materialId=material.id;
                                            lcMode.materialName=material.name;
                                            notifyDataSetChanged();
                                            dialog.dismiss();
                                        }
                                    }
                                })
                                .setCheckedIndex(checkIndex)
                                .show();
                    }
                });
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private Activity findActivity(@NonNull Context context) {
        if (context instanceof Activity) {
            return (Activity) context;
        } else if (context instanceof ContextWrapper) {
            return findActivity(((ContextWrapper) context).getBaseContext());
        } else {
            return null;
        }
    }

    /**
     * 刷新
     *
     * @param
     */
    public void refresh() {
        Activity activity = findActivity(context);
        if (activity != null) {
            activity.runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    try {
                        notifyDataSetChanged();
                    } catch (Exception e) {

                    }
                }
            });
        }
    }

    @Override
    public int getItemCount() {
        return liaos.size();
    }

    public static class MyLCViewHolder1 extends RecyclerView.ViewHolder {
        TextView xuhao;
        TextView name;
        ImageView wuliaoimage;
        public MyLCViewHolder1(View view) {
            super(view);
            xuhao = view.findViewById(R.id.xuhao);//序号
            name = view.findViewById(R.id.wuliaoname);
            wuliaoimage=view.findViewById(R.id.wuliaoimage);
        }
    }
}


