package com.bonait.bnframework.modules.home.adapter;

import android.app.Activity;
import android.content.Context;
import android.content.ContextWrapper;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.bonait.bnframework.R;
import com.bonait.bnframework.common.constant.MessageName;
import com.bonait.bnframework.common.db.QueryDB;
import com.bonait.bnframework.common.db.mode.BPA_GOODS;
import com.bonait.bnframework.common.image.MyBitmapUtils;
import com.bonait.bnframework.common.message.MessageManager;
import com.bonait.bnframework.common.utils.AlertDialogUtils;
import com.qmuiteam.qmui.widget.dialog.QMUIDialog;
import com.qmuiteam.qmui.widget.dialog.QMUIDialogAction;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class newmakegood_adapter  extends RecyclerView.Adapter<RecyclerView.ViewHolder> {

    private final LayoutInflater mLayoutInflater;

    private Context context;

    //图标
    private MyBitmapUtils myBitmapUtils = new MyBitmapUtils();

    public List<Object> Data = new ArrayList<>();

    public newmakegood_adapter(Context context, List<Object> data) {
        this.context = context;
        mLayoutInflater = LayoutInflater.from(context);
        Data = data;
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View inflate = mLayoutInflater.inflate(R.layout.newmakegood, parent, false);
        return new newgood_adapter.MyLCViewHolder1(inflate);
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        try {
            if (holder instanceof newgood_adapter.MyLCViewHolder1) {

                BPA_GOODS goods = (BPA_GOODS) Data.get(position);
                newgood_adapter.MyLCViewHolder1 myViewHolder = (newgood_adapter.MyLCViewHolder1) holder;

                myViewHolder.Tag_text.setText(goods.name);
                //设置图片
                if (!goods.url.equals("未知")) {
                    myBitmapUtils.disPlay(myViewHolder.ImageUrl, goods.url);
                }

                /**
                 * 图片点击后打开
                 */
                myViewHolder.ImageUrl.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View view) {
                        MessageManager.getInstance().sendMessage(MessageName.ClickMakeGoodNew,goods);
                    }
                });



            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 删除数据
     *
     * @param
     */
    public void Detele(BPA_GOODS goods) {
        QueryDB.DeleteGoods(goods);

        Iterator<Object> it= Data.iterator();
        while (it.hasNext())
        {
            BPA_GOODS s=(BPA_GOODS)it;
            if(s.id.equals(goods.id))
            {
                it.remove();
                notifyDataSetChanged();
            }
        }

    }

    private Activity findActivity(@NonNull Context context) {
        if (context instanceof Activity) {
            return (Activity) context;
        } else if (context instanceof ContextWrapper) {
            return findActivity(((ContextWrapper) context).getBaseContext());
        } else {
            return null;
        }
    }

    /**
     * 刷新
     *
     * @param
     */
    public void refresh() {
        Activity activity = findActivity(context);
        if (activity != null) {
            activity.runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    try {
                        notifyDataSetChanged();
                    } catch (Exception e) {

                    }
                }
            });
        }
    }

    @Override
    public int getItemCount() {
        return Data.size();
    }

    public static class MyLCViewHolder1 extends RecyclerView.ViewHolder {
        ImageView ImageUrl;
        TextView Tag_text;

        public MyLCViewHolder1(View view) {
            super(view);
            ImageUrl = view.findViewById(R.id.ImageUrl);

            Tag_text = view.findViewById(R.id.Tag_text);

        }
    }
}
