package com.bonait.bnframework.modules.home.fragment;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.core.content.ContextCompat;
import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;
import androidx.recyclerview.widget.RecyclerView;

import android.content.Context;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.AdapterView;
import android.widget.FrameLayout;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.bonait.bnframework.R;
import com.bonait.bnframework.common.base.BaseFragment;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.model.mode.ResMenuLeft;
import com.bonait.bnframework.modules.home.adapter.FragmentAdapter;
import com.bonait.bnframework.modules.home.adapter.jiaoyan_adapter;
import com.bonait.bnframework.modules.home.fragment.from.fragment.JiaoYan_dzcjy_fragment;
import com.bonait.bnframework.modules.home.fragment.from.fragment.JiaoYan_lsjy_fragment;
import com.bonait.bnframework.modules.home.fragment.from.fragment.JiaoYan_sdkz_fragment;
import com.bonait.bnframework.modules.home.fragment.from.fragment.JiaoYan_wdsz_fragment;
import com.bonait.bnframework.modules.home.fragment.from.fragment.JiaoYan_zdqx_fragment;
import com.orhanobut.logger.Logger;
import com.qmuiteam.qmui.widget.QMUITopBarLayout;
import com.qmuiteam.qmui.widget.QMUIViewPager;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;

public class JiaoYanFragment extends BaseFragment {


    @BindView(R.id.topbar)
    QMUITopBarLayout mTopBar;//顶部标题

    @BindView(R.id.rv_left)
    ListView rv_left;//左侧菜单

    @BindView(R.id.viewpager_jiaoyan)
    QMUIViewPager viewpager_jiaoyan;//右侧控件

    private Context context;
    public static int mPosition;

    public ArrayList<ResMenuLeft> menuModes=new ArrayList<>();

    public JiaoYanFragment() {
    }

    @Override
    protected View onCreateView() {
        View root = LayoutInflater.from(getActivity()).inflate(R.layout.fragment_jiaoyan, null);
        ButterKnife.bind(this, root);
        return root;
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        context = getContext();
        initTopBar();
        initData();
    }

    public jiaoyan_adapter adapter;
    /**
     * 初始化TopBar
     */
    private void initTopBar() {
        mTopBar.setTitle("设备校正");
    }
    private List<Fragment> fragmentList;
    public void initData()
    {
        fragmentList = new ArrayList<>();
        menuModes.clear();
        menuModes.add(new ResMenuLeft(new JiaoYan_dzcjy_fragment(),"电子秤校验", R.mipmap.dzcjy, R.mipmap.dzcjy_select,true));
        menuModes.add(new ResMenuLeft(new JiaoYan_lsjy_fragment(),"流速校验", R.mipmap.lsjy, R.mipmap.lsjy_select,false));
        menuModes.add(new ResMenuLeft(new JiaoYan_wdsz_fragment(),"温度设置", R.mipmap.lsjy, R.mipmap.lsjy_select,false));
        menuModes.add(new ResMenuLeft(new JiaoYan_zdqx_fragment(),"自动清洗", R.mipmap.zdqx1, R.mipmap.zdqx1_select,false));
        menuModes.add(new ResMenuLeft(new JiaoYan_sdkz_fragment(),"手动控制", R.mipmap.sdkz, R.mipmap.sdkz_select,false));

        for(ResMenuLeft item:menuModes)
        {
            fragmentList.add(item.fragment);
        }
        FragmentAdapter fragmentAdapter=new FragmentAdapter(getChildFragmentManager(),fragmentList);
        viewpager_jiaoyan.setAdapter(fragmentAdapter);
        viewpager_jiaoyan.setOffscreenPageLimit(5);
        viewpager_jiaoyan.setCurrentItem(0);

        adapter=new jiaoyan_adapter(getContext(),menuModes);
        rv_left.setAdapter(adapter);
        rv_left.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> adapterView, View view, int i, long l) {
                ItemClick(adapterView,view,i,l);
            }
        });
    }

    /**
     * Item 点击事件
     * @param adapterView
     * @param view
     * @param position
     * @param id
     */
    public void ItemClick(AdapterView<?> adapterView, View view, int position, long id) {
        //即使刷新adapter
        mPosition=position;
        adapter.notifyDataSetChanged();
        viewpager_jiaoyan.setCurrentItem(position);
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        Logger.d("第一页销毁");
    }

    /**
     * 当在activity设置viewPager + BottomNavigation + fragment时，
     * 为防止viewPager左滑动切换界面，与fragment左滑返回上一界面冲突引起闪退问题，
     * 必须加上此方法，禁止fragment左滑返回上一界面。
     * <p>
     * 切记！切记！切记！否则会闪退！
     * <p>
     * 当在fragment设置viewPager + BottomNavigation + fragment时，则不会出现这个问题。
     */
    @Override
    protected boolean canDragBack() {
        return false;
    }
}