package com.bonait.bnframework.modules.home.fragment.from;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import android.content.Context;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.SectionIndexer;

import com.bonait.bnframework.R;
import com.bonait.bnframework.common.base.BaseActivity;
import com.bonait.bnframework.common.base.BaseFragment;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.constant.DataBus;
import com.bonait.bnframework.common.db.res.lcMode;
import com.bonait.bnframework.common.linktab.LeftAdapter;
import com.bonait.bnframework.common.linktab.LinkMode;
import com.bonait.bnframework.common.linktab.RightAdapter;
import com.bonait.bnframework.common.linktab.TopItemDecoration;
import com.bonait.bnframework.modules.home.adapter.lcsz_adapter;
import com.bonait.bnframework.modules.home.fragment.GongnengFragment;
import com.bonait.bnframework.modules.home.fragment.from.fragment.Jcsjgl_sxgl_fragment;
import com.bonait.bnframework.modules.home.fragment.from.fragment.Jcsjgl_wl_fragment;
import com.chad.library.adapter.base.BaseQuickAdapter;
import com.chad.library.adapter.base.listener.OnItemChildClickListener;
import com.google.android.material.bottomnavigation.BottomNavigationView;
import com.qmuiteam.qmui.arch.QMUIFragment;
import com.qmuiteam.qmui.arch.QMUIFragmentPagerAdapter;
import com.qmuiteam.qmui.widget.QMUITopBarLayout;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.stream.Collectors;

import butterknife.BindView;
import butterknife.ButterKnife;

public class SilosActivity extends BaseFragment {

    @BindView(R.id.topbar)
    QMUITopBarLayout mTopBar;
    @BindView(R.id.rv_left)
    RecyclerView rv_left;
    @BindView(R.id.rv_right)
    RecyclerView rv_right;
    private Context context;
    ArrayList<lcMode> lcModes = new ArrayList<>();

    @Override
    protected View onCreateView() {
        View root = LayoutInflater.from(getActivity()).inflate(R.layout.activity_silos, null);
        ButterKnife.bind(this, root);
        return root;
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        context = getContext();
        initTopBar();
        InitData();
    }

    private void initTopBar() {
        mTopBar.setTitle("料仓管理");
        mTopBar.addLeftImageButton(R.mipmap.fanhui, R.id.topbar).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                onDestroy();
                ConfigName.getInstance().fragmentAdapter.replaceFragment(0, new GongnengFragment());
            }
        });
    }

    public List<LinkMode> Fdata = new ArrayList<>();

    /**
     * 初始化数据
     */
    public void InitData() {
        lcModes = DataBus.getInstance().ResGetLc();
        Fdata.clear();
        LinkedHashMap<String,List<Object>> map=new LinkedHashMap<>();
        for(lcMode item :lcModes)
        {
            if(map.containsKey(item.name))
            {
                map.get(item.name).add(item);
            }else
            {
                List<Object> lc=new ArrayList<>();
                lc.add(item);
                map.put(item.name,lc);
            }
        }
        /**
         * 编例HashMap中所有key跟value的值
         */
        int i=0;
        for(Object key:map.keySet()){
            List<Object> value =  map.get(key);

            Fdata.add(new LinkMode(key.toString(),value,i==0?true:false));
            i++;
        }

        LinearLayoutManager manager = (LinearLayoutManager) rv_right.getLayoutManager();
        LeftAdapter leftAdapter = new LeftAdapter(R.layout.item_left_lc, Fdata,getResources(),manager);
        RightAdapter rightAdapter = new RightAdapter(R.layout.item_right_lc, Fdata,getResources());
        rv_left.setAdapter(leftAdapter);
        rv_right.setAdapter(rightAdapter);

        //添加分组悬浮效果
        List<String> typeListener = new ArrayList<>();
        for (LinkMode item : Fdata) {
            typeListener.add((String) item.type);
        }
        TopItemDecoration top = new TopItemDecoration(context, typeListener);
        rv_right.addItemDecoration(top);

        //左侧联动
        rv_right.addOnScrollListener(new RecyclerView.OnScrollListener() {
            @Override
            public void onScrolled(@NonNull RecyclerView recyclerView, int dx, int dy) {
                super.onScrolled(recyclerView, dx, dy);
                int firstItemPosition = manager.findFirstVisibleItemPosition();
                if (firstItemPosition != -1 && dy != 0) {
                    rv_left.smoothScrollToPosition(firstItemPosition);
                    leftAdapter.setChoose(firstItemPosition);
                }
            }
        });
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
    }

    @Override
    protected boolean canDragBack() {
        return false;
    }
}