package com.bonait.bnframework.modules.home.fragment.mode;

import android.content.Context;
import android.util.AttributeSet;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import androidx.annotation.Nullable;
import androidx.recyclerview.widget.RecyclerView;

import com.bonait.bnframework.R;
import com.bonait.bnframework.common.constant.DataBus;
import com.bonait.bnframework.common.db.QueryDB;
import com.bonait.bnframework.common.db.mode.BPA_GOODPROPERTY;
import com.bonait.bnframework.common.db.mode.BPA_GOODS;
import com.bonait.bnframework.common.db.mode.BPA_GOODSRECIPE;
import com.bonait.bnframework.common.db.mode.BPA_GOODSRECIPENAME;
import com.bonait.bnframework.common.db.mode.BPA_MATERIAL;
import com.bonait.bnframework.common.db.res.ResGoodProperty;
import com.bonait.bnframework.common.db.res.ResGoodsRecipe;
import com.bonait.bnframework.common.db.res.ResMaterilas;
import com.bonait.bnframework.common.helper.I.MyClickListener;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.bonait.bnframework.common.view.MyLayoutManager;
import com.bonait.bnframework.modules.home.adapter.newmeatrilselect_adapter;
import com.bonait.bnframework.modules.home.adapter.newneatril_adapter;
import com.bonait.bnframework.modules.home.adapter.pfsx_adapter;
import com.bonait.bnframework.modules.home.adapter.sx_adapter;
import com.bonait.bnframework.modules.home.adapter.wl_adapter;
import com.bonait.bnframework.modules.home.adapter.xxpf_adapter;

import java.util.ArrayList;

import butterknife.BindView;
import butterknife.ButterKnife;

public class add_pf_control extends LinearLayout implements MyClickListener {


    @BindView(R.id.peifang_queren)
    Button peifang_queren;

    @BindView(R.id.close_from)
    Button close_from;

    @BindView(R.id.recycler_view_wl_click)
    RecyclerView recycler_view_wl_click;

    public BPA_GOODSRECIPENAME bpaGoodsrecipename=null;
    public BPA_GOODS Good=null;
    @BindView(R.id.edittext)
    EditText edittext;//配方名称

    @BindView(R.id.datatab_sx)
    ListView datatab_sx;

    @BindView(R.id.datatab_pf)
    ListView datatab_pf;

    @BindView(R.id.title)
    TextView title;//配方名称
    /**
     * 属性数据
     */
    ArrayList<ResGoodProperty> bpa_goodproperties = new ArrayList<>();

    /**
     * 当前物料数据
     */
    public ArrayList<BPA_MATERIAL> resMaterilas=new ArrayList<>();



    /**
     * 点击事件
     */
    public MyClickListener mListener=null;
    private View root;
    public add_pf_control(Context context, @Nullable AttributeSet attrs) {
        super(context, attrs);
        root= LayoutInflater.from(context).inflate(R.layout.dialog_add_pf, this);
        ButterKnife.bind(this, root);
        Init();
    }


    public void Init()
    {

        //初始化界面控件的事件
        initEvent();
    }


    private void initData()
    {
        //1.查询物料数据 填充物料点击事件
        resMaterilas.clear();
        resMaterilas= QueryDB.GetMaterialALL();
        MyLayoutManager layout = new MyLayoutManager();
        layout.setAutoMeasureEnabled(true);
        recycler_view_wl_click.setLayoutManager(layout);
        newneatril_adapter adapter = new newneatril_adapter(getContext(), resMaterilas, new MyClickListener() {
            @Override
            public void clickListener(View v, Object data) {
                BPA_MATERIAL m=(BPA_MATERIAL)data;

                ResGoodsRecipe cipe=new ResGoodsRecipe();
                cipe.sort=0;
                cipe.materialID=m.id;
                cipe.materialName=m.name;
                cipe.value="0";
                DataBus.getInstance().Recipe.add(cipe);

                adapter4.notifyDataSetChanged();
            }

            @Override
            public void clickListenerNew(View v, int k, Object data) {

            }
        });
        recycler_view_wl_click.setAdapter(adapter);

        //2.填充规则数据，查询所有属性大类
        bpa_goodproperties.clear();
        ArrayList<BPA_GOODPROPERTY> da = QueryDB.GetGoodsPropertyALL("0");
        for (BPA_GOODPROPERTY item:da)
        {
            ResGoodProperty re=new ResGoodProperty();
            re.id=item.id;
            re.name=item.name;

            ArrayList<BPA_GOODPROPERTY> zsx =QueryDB.GetGoodsPropertyALL(item.id);
            re.child=new ArrayList<>();


            ArrayList<ResGoodProperty> _chid = new ArrayList<>();
            for (BPA_GOODPROPERTY k:zsx)
            {
                ResGoodProperty m=new ResGoodProperty();
                m.id=k.id;
                m.name=k.name;
                if(bpaGoodsrecipename!=null && bpaGoodsrecipename.design!=null && !bpaGoodsrecipename.design.isEmpty() && bpaGoodsrecipename.design.contains(k.id))
                {
                    m.isSelect=true;
                }else
                {
                    m.isSelect=false;
                }
                _chid.add(m);
            }
            re.child=_chid;

            bpa_goodproperties.add(re);
        }

        if(bpaGoodsrecipename==null)
        {
            for(ResGoodProperty item:bpa_goodproperties)
            {
                int i=0;
                for(ResGoodProperty c:item.child)
                {
                    if(i==0)
                    {
                        c.isSelect=true;
                    }
                    i++;
                }
            }
        }


        pfsx_adapter sxadapter = new pfsx_adapter(getContext(), R.layout.pfsx_item, bpa_goodproperties, this);
        datatab_sx.setAdapter(sxadapter);

        InitTab();
    }
    xxpf_adapter adapter4;
    public void InitTab()
    {
        DataBus.getInstance().Recipe.clear();
        if(bpaGoodsrecipename!=null)
        {
            DataBus.getInstance().Recipe = QueryDB.GetGoodsSreciperecipeList(bpaGoodsrecipename.id);

        }else
        {
            for(BPA_MATERIAL wl:resMaterilas)
            {
                if(Good.materialids.contains(wl.id))
                {
                    ResGoodsRecipe cipe=new ResGoodsRecipe();
                    cipe.sort=0;
                    cipe.materialID=wl.id;
                    cipe.materialName=wl.name;
                    cipe.value="0";
                    cipe.goodsID=Good.id;
                    DataBus.getInstance().Recipe.add(cipe);
                }
            }
        }
        adapter4= new xxpf_adapter(getContext(), R.layout.xxpf_item, DataBus.getInstance().Recipe,this);
        datatab_pf.setAdapter(adapter4);
    }


    /**
     * 设置数据
     * @param name
     */
    public void SetData(BPA_GOODSRECIPENAME name, BPA_GOODS good)
    {
        try {
            bpaGoodsrecipename=name;
            Good=good;
            if(name!=null)
            {
                edittext.setText(bpaGoodsrecipename.name+"");
            }else
            {
                edittext.setText("");
            }

            title.setText(Good.name+"");
            initData();
        }catch (Exception ex)
        {

        }
    }


    private void initEvent()
    {
        peifang_queren.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View view) {
                if (mListener != null) {
                    SaveData();
                    mListener.clickListenerNew(view,1,null);
                }
            }
        });
        close_from.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (mListener != null) {
                    mListener.clickListenerNew(v,0,null);
                }
            }
        });
    }

    /**
     * 保存数据
     */
    public void SaveData()
    {
        if(DataValidation())
        {
            if(bpaGoodsrecipename==null)//新增
            {
                //新增配方名称
                BPA_GOODSRECIPENAME n=new BPA_GOODSRECIPENAME();
                n.name=pfname;
                n.design=ggids;
                n.goodsID=Good.id;
                QueryDB.AddGoodsRecipeName(n);
                //新增配方信息
                for (ResGoodsRecipe i:DataBus.getInstance().Recipe)
                {
                    BPA_GOODSRECIPE good=new BPA_GOODSRECIPE();
                    good.materialID=i.materialID;
                    good.recipeID=n.id;
                    good.goodsID=Good.id;
                    good.value=i.value;
                    good.sort=i.sort;


                    QueryDB.AddGoodsSrecipe(good);
                }
            }else //修改
            {
                bpaGoodsrecipename.name=pfname;
                bpaGoodsrecipename.design=ggids;
                bpaGoodsrecipename.goodsID=Good.id;
                QueryDB.UpdateGoodsRecipeName(bpaGoodsrecipename);

                ArrayList<ResGoodsRecipe> re= QueryDB.GetGoodsSreciperecipeList(bpaGoodsrecipename.id);
                for(ResGoodsRecipe item:re)
                {
                    QueryDB.DeleteGoodsSrecipe(item.id);
                }

                for (ResGoodsRecipe i:DataBus.getInstance().Recipe)
                {
                    BPA_GOODSRECIPE good=new BPA_GOODSRECIPE();
                    good.materialID=i.materialID;
                    good.recipeID=bpaGoodsrecipename.id;
                    good.goodsID=Good.id;
                    good.value=i.value;
                    good.sort=i.sort;

                    QueryDB.AddGoodsSrecipe(good);
                }
            }
        }
    }


    String pfname="";//配方名称集合
    String ggids="";//规格id集合
    /**
     * 数据验证
     */
    public boolean DataValidation()
    {
        boolean isSuceess=false;
        //1.数据名称不能为空
        pfname=edittext.getText().toString();
        if(pfname.isEmpty())
        {
            ToastUtils.info("配方名称不能为空!");
            return isSuceess;
        }

        ggids="";
        for(ResGoodProperty item:bpa_goodproperties)
        {
            for(ResGoodProperty k:item.child)
            {
                if(k.isSelect)
                {
                    ggids+=k.id+",";
                }
            }
        }

        if(!ggids.isEmpty())
        {
            ggids=ggids.substring(0, ggids.length() - 1);
        }

        //2.必须选择一个规格
        if(DataBus.getInstance().Recipe.size()<=0)
        {
            ToastUtils.info("配方数据表格不能为空!");
            return isSuceess;
        }

        return true;
    }


    /**
     * 点击事件
     *
     * @param v
     * @param data
     */
    @Override
    public void clickListener(View v, Object data) {
        switch (v.getId()) {
            case R.id.name://点击 修改

                break;
            case R.id.button_item://删除按钮

                break;
        }
    }

    @Override
    public void clickListenerNew(View v, int k, Object data) {

    }
}
